﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.IO.Ports;
using System.Windows.Forms;
//using DlpLibDemo2;


namespace DlpLibDemo
{
   
	public class SerialReader : IDisposable
	{
		SerialPort serialPort = null;
		protected const int TIMEOUT = 500;
		protected System.Threading.Timer timer = null;
		protected StringBuilder data = new StringBuilder();
		public event EventHandler<EventArgs<string>> Loaded;

		public SerialReader(string port)
		{
			timer = new System.Threading.Timer(TimerExpired, this, Timeout.Infinite, Timeout.Infinite);
			serialPort = new SerialPort(port);
			serialPort.DataReceived += new SerialDataReceivedEventHandler(serialPort_DataReceived);
			serialPort.Open();
		}

		void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
		{
			data.Append(serialPort.ReadExisting());
			Restart();
		}

		private void OnLoaded(string data)
		{
          // MessageBox.Show(data);
      //      MainForm._AdressText(data);
            MessageBox.Show("The ID info has been received. Click OK and then 'Populate Fields' button", "Success", MessageBoxButtons.OK);
            MainForm.scannedText = data;
			var temp = Loaded;
            if (temp != null)
            {
                temp(this, new EventArgs<string>(data));
            }
		}

		private static void TimerExpired(object instance)
		{
			var reader = (SerialReader)instance;
			if (reader.data.Length != 0)
			{
				string str = reader.data.ToString();
				reader.data.Remove(0, reader.data.Length);
				reader.OnLoaded(str);
			}
		}

		protected void Restart()
		{
			timer.Change(TIMEOUT, Timeout.Infinite);
		}

		#region IDisposable Members

		public void Dispose()
		{
			timer.Dispose();
			serialPort.Dispose();
			GC.SuppressFinalize(this);
		}

		#endregion
	}

}
